Program BFPFTG;        (* 5X5 Playfair Cryptosystem *)
                       (*   Amarillo, Texas  1995   *)

{$G+}                                                           { 80286 Code }
{$M 16384,0,655360}                              { stackSize,heapMin,heapMax }
Uses  DOS,Trigph;
Const bell=#7; cr=#13; lf=#10;
Type  str10=Array[1..10] Of String;
Var   flag,flg   :Boolean;
      gulp,
      left,right :Char;
      grid       :Packed Array[1..5,1..5] Of Char;     { 5 rows by 5 columns }
      a,b,count,i,
      itr,j,k,lct,
      lCol,lRow,
      rCol,rRow,
      route,kwl,
      numFiles,
      wls        :Integer;
      rte        :Array[0..10] Of Integer;
      cnt,oldScr,
      kk,score   :LongInt;
      hiScore    :Array[1..10] Of LongInt;
      cipherFile,
      cipherText,
      crib,
      ct1,ct2,
      dataFile,
      key,keyType,
      keyWord,
      plainText,
      sqr,square,
      title,tmp  :String;
      fList      :Array[1..75] Of String[34];
      al,slt     :str10;
      f0,f1      :Text;
      h1,m1,s1,t1,
      h2,m2,s2,t2:Word;

{****************************************************************************}

Procedure  ScoreTrigraphs(Var keyPhrase,plainText:String);
  Var  flag   :Boolean;
       i,j    :Integer;
       k,score:LongInt;
       tmp    :String;

  Function  TestDups(Var plainText:String; Var slt:str10): Boolean;
    Var  flag:Boolean;
         i   :Integer;
    Begin
      flag:=True;
      For i:=10 DownTo 1 Do                                  { Test for Dups }
        If plainText=slt[i] Then flag:=False;
      TestDups:=flag
    End;

  Begin
    score:=0;                                             { Score Trigraphs  }
    For i:=1 To lct-2 Do
      score:=score + tg[(Ord(plainText[i])  -64) * 676 +  { Base 26 Hundreds }
                        (Ord(plainText[i+1])-64) *  26 +  { Base 26 Tens     }
                         Ord(plainText[i+2])-64];         { Base 26 Units    }

    flag:=TestDups(plainText,slt);

    If flag And (hiScore[10]<score) Then             { New Score > Old Score }
      Begin
        al[10]:=keyPhrase;
        hiScore[10]:=score;
        rte[10]:=route;
        slt[10]:=plainText;
        For i:=1 To 9 Do                                          { Exchange }
          For j:=i+1 To 10 Do
            If hiScore[i]<hiScore[j] Then
              Begin
                tmp:=al[i]; al[i]:=al[j]; al[j]:=tmp;
                k:=hiScore[i]; hiScore[i]:=hiScore[j]; hiScore[j]:=k;
                k  :=rte[i]; rte[i]:=rte[j]; rte[j]:=k;
                tmp:=slt[i]; slt[i]:=slt[j]; slt[j]:=tmp
              End
      End
  End;

{****************************************************************************}

                  (* Both characters are on the same row *)
Procedure  Sort_Row(lr,lc,rr,rc:Integer);
  Var  x,y,z:Integer;
  Begin
    x :=-1; y:=0; z:=5;
    Inc(lc,x);
    Inc(rc,x);
    If lc=y Then lc:=z;
    If rc=y Then rc:=z;
    plainText:=Concat(plainText,grid[lr,lc],grid[rr,rc])
  End;

                 (* Both characters are on the same column *)
Procedure  Sort_Col(lr,lc,rr,rc:Integer);
  Var  x,y,z:Integer;
  Begin
    x :=-1; y:=0; z:=5;
    Inc(lr,x);
    Inc(rr,x);
    If lr=y Then lr:=z;
    If rr=y Then rr:=z;
    plainText:=Concat(plainText,grid[lr,lc],grid[rr,rc])
 End;

           (* Both characters are on a different row and column *)
Procedure  Sort_Rectangle(lr,lc,rr,rc:Integer);
  Begin
    plainText:=Concat(plainText,grid[lr,lc],grid[rr,rc])
  End;

{****************************************************************************}

                              (* Main Program *)
Begin
  If ParamCount<>0 Then cipherFile:=ParamStr(1) Else
    Begin
      Write(cr,lf,' Enter Cipher File Name: '); ReadLn(cipherFile)
    End;

  Assign(f0,cipherFile);                                  { Open Cipher File }
  {$I-} Reset(f0); {$I+}
  If IOResult>0 Then Begin WriteLn(cr,lf,' *** Bad Filename ***'); Halt End;

  GetTime(h1,m1,s1,t1);
  ReadLn(f0,title);
  WriteLn(cr,lf,title);
  ReadLn(f0,keyType);                                             { Not Used }
  WriteLn(keyType);
  ReadLn(f0,crib);                                                { Not Used }
  WriteLn(crib);
  ReadLn(f0,ct1);                                                 { 1st Line }
  WriteLn(ct1);
  ReadLn(f0,ct2);                                                 { 2nd Line }
  WriteLn(ct2);
  ct1:=Concat(ct1,ct2);
  ReadLn(f0,ct2);                                                 { 3rd Line }
  WriteLn(ct2,cr,lf);
  ct1:=Concat(ct1,ct2);
  cipherText:='';
  For i:=1 To Length(ct1) Do                             { Strip Punctuation }
    If ct1[i] In['A'..'Z','a'..'z'] Then
      cipherText:=Concat(cipherText,UpCase(ct1[i]));
  ReadLn(f0,tmp);                                     { Number of Data Files }
  If tmp[1] In['1'..'9'] Then numFiles:=Ord(tmp[1]) - 48 Else Halt;
  If tmp[2] In['0'..'9'] Then numFiles:=(numFiles*10)+Ord(tmp[2])-48;
  For i:=1 To numFiles Do ReadLn(f0,fList[i]);
  Close(f0);                                             { Close Cipher File }

  lct:=Length(cipherText);
  WriteLn(' Length of ciphertext: ',lct,cr,lf);

  Delete(cipherFile,Pos('.',cipherFile),1);               { Open Output File }
  If Length(cipherFile)>8 Then cipherFile:=Copy(cipherFile,1,8);
  Assign(f1,cipherFile+'.ANS'); ReWrite(f1);
                                                      { Try Different Routes }
  For route:=1 To 12 Do                                             { A/M-53 }
    Begin
      WriteLn(' Route: ',route);

      For i:=1 To 10 Do                                    { Null the Scores }
        Begin
          al[i]:='';                                     { Keyword or Phrase }
          hiScore[i]:=0;                                 { Trigraph Scoring  }
          rte[i]:=0;                                     { Route             }
          slt[i]:=''                                     { Plaintext         }
        End;

      flg   :=False;
      oldScr:=0;
      wls   :=1;
      Repeat                                                    { Iterations }
        dataFile:=fList[wls];
        Assign(f0,dataFile);                                { Open Data File }
        {$I-} Reset(f0); {$I+}
        If IOResult>0 Then
          Begin
            WriteLn(cr,lf,' ***  Bad Filename  ***',
                    cr,lf,' ***  ',dataFile,'    ***');
            Halt
          End;
        WriteLn(dataFile:13,cr,lf);

        While Not EOF(f0) Do
          Begin
            ReadLn(f0,keyWord);
          { WriteLn(keyWord); }                   { 12% faster without print }
            kwl:=Length(keyWord);
            key:=keyWord;
                                                      { Exchange 'J' for 'I' }
            For i:=1 To kwl Do
              If keyWord[i]='J' Then
                Begin
                  Delete(keyWord,i,1); Insert('I',keyWord,i)
                End;
                                                  { Remove Duplicate Letters }
            For i:=1 To kwl-1 Do
              For j:=kwl DownTo i+1 Do
                If keyWord[i]=keyWord[j] Then Delete(keyWord,j,1);
            kwl:=Length(keyWord);
                                                { 25 Characters for the Grid }
            sqr:='ABCDEFGHIKLMNOPQRSTUVWXYZ';
                                                   { Build the Playfair Grid }
            For i:=1 To kwl Do
              Begin
                j:=Pos(keyWord[i],sqr);
                If j>0 Then Delete(sqr,j,1)
              End;
            sqr:=Concat(keyWord,sqr);

            Case route Of
               1:Begin                                   { Simple Horizontal }
                   square:=sqr[ 1] + sqr[ 2] + sqr[ 3] + sqr[ 4] + sqr[ 5] +
                           sqr[ 6] + sqr[ 7] + sqr[ 8] + sqr[ 9] + sqr[10] +
                           sqr[11] + sqr[12] + sqr[13] + sqr[14] + sqr[15] +
                           sqr[16] + sqr[17] + sqr[18] + sqr[19] + sqr[20] +
                           sqr[21] + sqr[22] + sqr[23] + sqr[24] + sqr[25]
                 End;
               2:Begin                                     { Simple Vertical }
                   square:=sqr[ 1] + sqr[ 6] + sqr[11] + sqr[16] + sqr[21] +
                           sqr[ 2] + sqr[ 7] + sqr[12] + sqr[17] + sqr[22] +
                           sqr[ 3] + sqr[ 8] + sqr[13] + sqr[18] + sqr[23] +
                           sqr[ 4] + sqr[ 9] + sqr[14] + sqr[19] + sqr[24] +
                           sqr[ 5] + sqr[10] + sqr[15] + sqr[20] + sqr[25]
                 End;
               3:Begin                              { Alternating Horizontal }
                   square:=sqr[ 1] + sqr[ 2] + sqr[ 3] + sqr[ 4] + sqr[ 5] +
                           sqr[10] + sqr[ 9] + sqr[ 8] + sqr[ 7] + sqr[ 6] +
                           sqr[11] + sqr[12] + sqr[13] + sqr[14] + sqr[15] +
                           sqr[20] + sqr[19] + sqr[18] + sqr[17] + sqr[16] +
                           sqr[21] + sqr[22] + sqr[23] + sqr[24] + sqr[25]
                 End;
               4:Begin                                { Alternating Vertical }
                   square:=sqr[ 1] + sqr[10] + sqr[11] + sqr[20] + sqr[21] +
                           sqr[ 2] + sqr[ 9] + sqr[12] + sqr[19] + sqr[22] +
                           sqr[ 3] + sqr[ 8] + sqr[13] + sqr[18] + sqr[23] +
                           sqr[ 4] + sqr[ 7] + sqr[14] + sqr[17] + sqr[24] +
                           sqr[ 5] + sqr[ 6] + sqr[15] + sqr[16] + sqr[25]
                 End;
               5:Begin                           { Simple Diagonal, Downward }
                   square:=sqr[ 1] + sqr[ 2] + sqr[ 4] + sqr[ 7] + sqr[11] +
                           sqr[ 3] + sqr[ 5] + sqr[ 8] + sqr[12] + sqr[16] +
                           sqr[ 6] + sqr[ 9] + sqr[13] + sqr[17] + sqr[20] +
                           sqr[10] + sqr[14] + sqr[18] + sqr[21] + sqr[23] +
                           sqr[15] + sqr[19] + sqr[22] + sqr[24] + sqr[25]
                 End;
               6:Begin                             { Simple Diagonal, Upward }
                   square:=sqr[ 1] + sqr[ 3] + sqr[ 6] + sqr[10] + sqr[15] +
                           sqr[ 2] + sqr[ 5] + sqr[ 9] + sqr[14] + sqr[19] +
                           sqr[ 4] + sqr[ 8] + sqr[13] + sqr[18] + sqr[22] +
                           sqr[ 7] + sqr[12] + sqr[17] + sqr[21] + sqr[24] +
                           sqr[11] + sqr[16] + sqr[20] + sqr[23] + sqr[25]
                 End;
               7:Begin                     { Alternating, Diagonal, Downward }
                   square:=sqr[ 1] + sqr[ 2] + sqr[ 6] + sqr[ 7] + sqr[15] +
                           sqr[ 3] + sqr[ 5] + sqr[ 8] + sqr[14] + sqr[16] +
                           sqr[ 4] + sqr[ 9] + sqr[13] + sqr[17] + sqr[22] +
                           sqr[10] + sqr[12] + sqr[18] + sqr[21] + sqr[23] +
                           sqr[11] + sqr[19] + sqr[20] + sqr[24] + sqr[25]
                 End;
               8:Begin                        { Alternating Diagonal, Upward }
                   square:=sqr[ 1] + sqr[ 3] + sqr[ 4] + sqr[10] + sqr[11] +
                           sqr[ 2] + sqr[ 5] + sqr[ 9] + sqr[12] + sqr[19] +
                           sqr[ 6] + sqr[ 8] + sqr[13] + sqr[18] + sqr[20] +
                           sqr[ 7] + sqr[14] + sqr[17] + sqr[21] + sqr[24] +
                           sqr[15] + sqr[16] + sqr[22] + sqr[23] + sqr[25]
                 End;
               9:Begin                                   { Spiral, Clockwise }
                   square:=sqr[ 1] + sqr[ 2] + sqr[ 3] + sqr[ 4] + sqr[ 5] +
                           sqr[16] + sqr[17] + sqr[18] + sqr[19] + sqr[ 6] +
                           sqr[15] + sqr[24] + sqr[25] + sqr[20] + sqr[ 7] +
                           sqr[14] + sqr[23] + sqr[22] + sqr[21] + sqr[ 8] +
                           sqr[13] + sqr[12] + sqr[11] + sqr[10] + sqr[ 9]
                 End;
              10:Begin                              { Spiral, Anti-Clockwise }
                   square:=sqr[ 1] + sqr[16] + sqr[15] + sqr[14] + sqr[13] +
                           sqr[ 2] + sqr[17] + sqr[24] + sqr[23] + sqr[12] +
                           sqr[ 3] + sqr[18] + sqr[25] + sqr[22] + sqr[11] +
                           sqr[ 4] + sqr[19] + sqr[20] + sqr[21] + sqr[10] +
                           sqr[ 5] + sqr[ 6] + sqr[ 7] + sqr[ 8] + sqr[ 9]
                 End;
              11:Begin                                    { Spiral, Reversed }
                   square:=sqr[21] + sqr[22] + sqr[23] + sqr[24] + sqr[25] +
                           sqr[20] + sqr[ 7] + sqr[ 8] + sqr[ 9] + sqr[10] +
                           sqr[19] + sqr[ 6] + sqr[ 1] + sqr[ 2] + sqr[11] +
                           sqr[18] + sqr[ 5] + sqr[ 4] + sqr[ 3] + sqr[12] +
                           sqr[17] + sqr[16] + sqr[15] + sqr[14] + sqr[13]
                 End;
              12:Begin                               { Spiral, Anti-Reversed }
                   square:=sqr[25] + sqr[24] + sqr[23] + sqr[22] + sqr[21] +
                           sqr[10] + sqr[ 9] + sqr[ 8] + sqr[ 7] + sqr[20] +
                           sqr[11] + sqr[ 2] + sqr[ 1] + sqr[ 6] + sqr[19] +
                           sqr[12] + sqr[ 3] + sqr[ 4] + sqr[ 5] + sqr[18] +
                           sqr[13] + sqr[14] + sqr[15] + sqr[16] + sqr[17]
                 End
            End;
                                                   { Build the Playfair Grid }
            count:=1;
            For i:=1 To 5 Do
              For j:=1 To 5 Do
                Begin
                  grid[i,j]:=square[count];
                  Inc(count)
                End;
                                                       { Test for Odd Length }
            If Odd(Length(cipherText)) Then
              cipherText:=Concat(cipherText,'X');
            k:=0; plainText:='';
            Repeat
              Inc(k); left :=cipherText[k];
              Inc(k); right:=cipherText[k];
              For i:=1 To 5 Do
                For j:=1 To 5 Do
                  Begin
                    If left=grid[i,j] Then
                      Begin
                        lRow:=i; lCol:=j
                      End;
                    If right=grid[i,j] Then
                      Begin
                        rRow:=i; rCol:=j
                      End
                  End;
              If lRow=rRow Then Sort_Row(lRow,lCol,rRow,rCol) Else
                If lCol=rCol Then Sort_Col(lRow,lCol,rRow,rCol) Else
                  Sort_Rectangle(lRow,rCol,rRow,lCol)
            Until k=lct;

            ScoreTrigraphs(key,plainText)
          End;
        Close(f0);                                         { Close Data File }
        Inc(wls)
      Until wls>numFiles;

      WriteLn(f1,' Route: ',route);
      For i:=1 To 10 Do
        Begin
          Write(f1,hiScore[i]:6,'   ',al[i],'   '{,cr,lf,slt[i]});
          Case rte[i] Of
             1:WriteLn(f1,'Horizontal',rte[i]:3);
             2:WriteLn(f1,'Vertical',rte[i]:3);
             3:WriteLn(f1,'Horizontal, Alternate',rte[i]:3);
             4:WriteLn(f1,'Vertical, Alternate',rte[i]:3);
             5:WriteLn(f1,'Simple Diagonal, Downward',rte[i]:3);
             6:WriteLn(f1,'Simple Diagonal, Upward',rte[i]:3);
             7:WriteLn(f1,'Alternating Diagonal, Downward',rte[i]:3);
             8:WriteLn(f1,'Alternating Diagonal, Upward',rte[i]:3);
             9:WriteLn(f1,'Spiral, Clockwise',rte[i]:3);
            10:WriteLn(f1,'Spiral, Anti-Clockwise',rte[i]:3);
            11:WriteLn(f1,'Spiral, Reversed',rte[i]:3);
            12:WriteLn(f1,'Spiral, Anti-Reversed',rte[i]:3)
          End;
          ct2:=slt[i];
          For j:=1 To lct Do
            Begin
              Write(f1,ct2[j]);
              If (j Mod 65)=0 Then WriteLn(f1)
            End;
          WriteLn(f1)
        End;
      WriteLn(f1)
    End;
  Close(f1);                                             { Close Output File }

  GetTime(h2,m2,s2,t2);
  WriteLn(bell,cr,lf,' Done...');
  WriteLn(' Finished: ',h2:2,':',m2:2,':',s2:2,'.',t2:2);
  WriteLn(' Start   : ',h1:2,':',m1:2,':',s1:2,'.',t1:2)
End.
