program POLLUX;
  {
   Written in Borland's Turbo Pascal 4.0.
   Determines separator digits, by trial & error on every combination
        from 012 to 789 in procedures `compsep3' for 3 separators and
        `compsep4' for 4 separators (0123 to 6789).
   Puts separators into morse text, displays cipher on screen for solving
         plaintext on screen by trial & error.
   By BOATTAIL, November 21, 1991. Updated March 16, 1993.
   Assumes a color monitor. If you are using a monochrome display,
        delete all TextColor commands.
   Printer Commands are for an Epson FX dot matrix printer. If your
        printer is not Epson-compatible, change or delete the command
        strings in procedure `hardcopy'
   }
        USES Crt,Printer,Ciphlib;
        {uses `morsedecode' procedure and others from CIPHLIB.TPU, a library
        of standard cipher routines in Turbo Pascal 4.0}
        CONST
        Maxlen=600; {Maximum Characters in input strings}
        Maxdisplay=559; {Maximum characters displayed, 7 lines of 80, 0-559}
        test1='345994612783860345075921618092784034650795210678921861435349';
        test2='529764018527630853607218186249594357306047289108672510756943';
        test3='832486107529591436813278046905947521361384928765059074623918';
        test4='182476950125679804078362107534952196431827018627050347526191/';
        {Plain = Most widely used word in the world is ok say language ...}
        {E-8 NOV-DEC 1991 by RIG R. MORTIS}
        TYPE
        line = (num,morse,plain);
        VAR
        test           :String;  {test cipher text}
        exitflag       :Boolean;
        selnum         :Integer; {menu selection}
        intext         :txtarr; {cipher input array}
        txt            :array[line] of txtarr;
        clast          :Integer; {last element of cipher arrays}
        cnum           :intarr; {cipher digits in numbers}
        flag           :Boolean; {general purpose flag}
        solnum         :Integer; {how many sets of separators found?}
        numsep         :Integer; {number of separators, 3 or 4}
        sepsol         :array[0..10,0..3] of Byte; {sep solutions}
        opsep          :array[0..3] of Byte; {chosen separators}
        ddx            :array[0..9] of Char; {equivalents, dash, dot or x}
procedure ciphfill;
    var    x    :Integer;
    begin
    for x:=0 to clast do begin
        txt[num,x]:=intext[x];cnum[x]:=Ord(intext[x])-48;end;
    FillChar(ddx,Sizeof(ddx),' '); {clear dot-dash array to blanks}
    FillChar(txt[plain],Sizeof(txt[plain]),' '); {clear plaintext}
    end;
procedure sepfill(n:Integer); {put chosen separators into dot-dash array}
    var   x    :byte;
    begin
    for x:=0 to numsep-1 do begin opsep[x]:=sepsol[n,x];ddx[opsep[x]]:='x';end;
    end;
procedure morsefill; {fill morse text from dot-dash equivalents}
    var   x,y   :Integer;
    begin
    FillChar(txt[morse],Sizeof(txt[morse]),' '); {clear morse text}
    for x:=0 to 9 do
        for y:=0 to clast do txt[morse,y]:=ddx[cnum[y]];
    end;
procedure displayline(ln:line); {display cipher, morse, or plain}
    const   wid=80;
    var  f,g,h,k,t,z   :Integer;  endflag  :Boolean;
    begin
    g:=0;h:=wid-1;endflag:=false;f:=Ord(ln);t:=0;
    repeat
       if clast>Maxdisplay then z:=Maxdisplay else z:=clast;{limit display}
       if h>z then begin h:=z;endflag:=true;end;
       GotoXY(1,1+f+(3*t));Textcolor(f+10);
       for k:=g to h do Write(txt[ln,k]);
       Inc(t);Inc(g,wid);Inc(h,wid);
   until endflag=true;
   end;
procedure dispall; {display cipher, morse & plain}
    var  ln :line;
    begin
    Textmode(CO80);ClrScr;for ln:=num to plain do displayline(ln);
    end;
procedure choosesep; {which set of computed separators do you want to try?}
    var   w   :Integer;  flg :Boolean;
    begin
    if solnum=0 then begin
           message('Only One Possible Set',Cyan,9,20,false);any_key;end
        else begin
           digit_in('Which Separator Set? ',Blue,1,20,w);Write(w);
           yes_no(itc,White,1,24,flg);
           if flg=true then sepfill(w);
           end;
    end;
procedure compsep3; {deduce three separators by trying all combinations}
    var    b,i,j,k,n,sc,nsc :Integer;
    label  650,660,670;
    begin
    b:=0;
    for i:=0 to 7 do
        for j:= i+1 to 8 do
            for k :=j+1 to 9 do begin
              GotoXY(18,12);Write(i,' ',j,' ',k);sc:=0;nsc:=0;
              for n:=0 to clast do begin
                  if (cnum[n]=i) or (cnum[n]=j) or (cnum[n]=k) then goto 650;
                  if nsc=4 then goto 670 else begin Inc(nsc);sc:=0;goto 660;
                      end;
             650: if sc=2 then goto 670 else begin Inc(sc);nsc:=0;end;
             660: end; {of for n}
             sepsol[b,0]:=i;sepsol[b,1]:=j;sepsol[b,2]:=k;Inc(b);
        670: end; {of for k}
    solnum:=b-1; {number of separator solutions}
    end;
procedure compsep4; {deduce four separators by trial}
    var    b,h,i,j,k,n,sc,nsc,x   :Integer;
    label  750,760,770;
    begin
    b:=0;
    for h:=0 to 6 do
        for i:=h+1 to 7 do
            for j:=i+1 to 8 do
                for k:=j+1 to 9 do begin
                    GotoXY(18,12);Write(h,' ',i,' ',j,' ',k);sc:=0;nsc:=0;
                    for n:=0 to clast do begin
                       x:=cnum[n];
                       if (x=h) or (x=i) or (x=j) or (x=k) then goto 750;
                       if nsc=4 then goto 770 else begin
                            Inc(nsc);sc:=0;goto 760; end;
                  750: if sc=2 then goto 770 else begin Inc(sc);nsc:=0;end;
                  760: end; {of for n}
                  sepsol[b,0]:=h;sepsol[b,1]:=i;sepsol[b,2]:=j;sepsol[b,3]:=k;
                  Inc(b);
             770: end; {of for k}
    solnum:=b-1;
    end;
procedure displaysep; {display deduced separator set(s) on screen}
    var    f,g    :Integer;
    begin
    ClrScr;Textcolor(LightMagenta);GotoXY(1,6);Write('Separators:');
    for f:=0 to solnum do begin
        GotoXY(15,6+f);Textcolor(Cyan);Write(f,'  ');Textcolor(LightGreen);
        for g:=0 to numsep-1 do Write(sepsol[f,g],' ');end;
    end;
procedure decode; {change morse text to plain}
    var   x :Integer; strflag,blankflag :Boolean; xstr :Str6;
    begin
    FillChar(txt[plain],Sizeof(txt[plain]),' ');
    strflag:=false;blankflag:=false;xstr:='';
    for x:=0 to clast do
        case txt[morse,x] of
        'x' : begin
              if (strflag=true) and (blankflag=false) then begin
                  morsecode('d',xstr,txt[plain,x-1]);
                  strflag:=false;
                  end;
              blankflag:=false;xstr:='';
              end;
    '.','-' : begin xstr:=xstr+txt[morse,x];
                    strflag:=true;end;
        ' ' : begin strflag:=false;blankflag:=true;xstr:='';end;
        end;
    end;
procedure instruct; {display instructions while using substitution screen}
    begin
    GotoXY(1,22);Textcolor(LightGreen);Write('0123456789');
    Textcolor(LightCyan);
    GotoXY(1,24);Writeln('Use right and left arrows to move cursor');
    Write('Insert dot, dash, or blank below digit; Escape for Main Menu');
    Textcolor(Red);
    end;
procedure substitute; {interactive, trial & error solving on screen}
    var   x,indx   :Integer;  a,b  :Char; outflag :Boolean;
    begin
    ClrScr;dispall;instruct;indx:=0;outflag:=false;
    repeat
        GotoXY(1,23);TextColor(LightCyan);for x:=0 to 9 do Write(ddx[x]);
        GotoXY(indx+1,23);
        b:=Readkey;
        case b of
        ' ','.','-' : begin ddx[indx]:=b;morsefill;decode;
                            displayline(morse);displayline(plain);end;
        #0  : begin  a:=Readkey;
              case a of
                  #77 : indx:=(indx+11) mod 10; {left arrow}
                  #75 : indx:=(indx+9) mod 10; {right arrow}
                  end;
              end;
        #27  : outflag:=true; {escape key}
        end;
    until outflag=true;
    end;
procedure hardcopy; {printout cipher, morse, plain, dot-dash}
    const  dwon=#0#27#87#49#13; {NUL,Esc,W1,CR}   {Double Width On}
           dwoff=#27#87#48#13;  {Esc,W0,CR}       {Double Width Off}
           wid=40; {40 chars. per printed line}
    var  f,g,h  :Integer; out :Boolean; ln :line;
    begin
    Write(Lst,dwon); {double width printing on, CR}
    g:=0;h:=wid;out:=false;
    repeat
        if h>clast then begin h:=clast;out:=true;end;
        for ln:=num to plain do begin
           for f:=g to h do Write(Lst,txt[ln,f]);
           Write(Lst,#10#13); {LF,LF,CR}
           end;
       Inc(g,wid);Inc(h,wid);Write(Lst,#10); {blank line between rows}
    until out=true;
    Writeln(Lst,'0123456789');
    for f:=0 to 9 do Write(Lst,ddx[f]);
    Write(Lst,dwoff,#13#12); {double width printing off,CR,Form feed}
    end;
begin         {main body of program}
    test:=test1+test2+test3+test4; {test cipher assembled}
    exitflag:=false;
    repeat
        Textmode(CO40); {40 column color}
        ClrScr;Textcolor(LightBlue);GotoXY(10,1);flag:=false;
        Writeln('POLLUX CRYPTANALYSIS');Textcolor(Green);
        GotoXY(14,2);Writeln('By BOATTAIL'^J^J);Textcolor(LightCyan);
        Writeln('(1) Enter Cipher Digits'^J);
        Writeln('(2) Find Separators'^J);
        Writeln('(3) Display Cipher'^J);
        Writeln('(4) Change Separators'^J);
        Writeln('(5) Substitute in Cipher'^J);
        Writeln('(6) Hardcopy'^J);
        Writeln('(0) Exit to DOS'^J);
        digit_in(sbn,White,10,24,selnum);
        case selnum of
             1 : begin
                 cipherin(test,Maxlen,clast,intext);
                 yes_no(itc,White,1,24,flag);
                 if flag=true then begin
                     squeeze(['0'..'9'],clast,intext);
                     ciphfill;
                     end;
                 end;
             2 : begin
                 ClrSCr;
                 number_in('How Many Separators? ',Red,7,12,3,4,numsep);
                 if numsep=4 then compsep4 else compsep3;
                 sepfill(0);morsefill;displaysep;any_key;
                 end;
             3 : begin dispall;any_key;end;
             4 : begin displaysep;choosesep;morsefill;end;
             5 : substitute;
             6 : hardcopy;
             0 : begin ClrScr;yes_no(qtp,Red,7,12,exitflag);
                 end;
        end; {of case statement}
     until exitflag=true;
     Textmode(CO80);Textcolor(White); {80 column color}
end. {of program }